%read in an image and convert to grayscale if necessary
image = imread('images/2.jpg');
if(ndims(image)==3)
    image = rgb2gray(image);
end

%specify patch to align
x= 248; y = 278; width = 50; height = 50;

%apply a test transformation to generate the template
template = imtransform2(double(image),[1 0 0;0 1 0;5 5 1]);
template = template(y:y+height-1,x:x+width-1);

%specify the initial warp initialization
pinit = [1 0 x-1; 0 1 y-1];
NUM_ITERATIONS = 50;
sigmaXYChoices = [1,3,5,7,9]; sigmaFChoices = [1 2 4 6 8 10 15 20 30];
USE_SIC = false;
numBins = 64;
downsampleScale = 2;

%example of a DF method
fit = dfAlign(double(image),double(template),pinit,NUM_ITERATIONS,downsampleScale,...
    USE_SIC,numBins,sigmaXYChoices,sigmaFChoices);

%fit = dfAlignSIFT(double(image),double(template),pinit,NUM_ITERATIONS,downsampleScale,sigmaXYChoices);

subplot(2,2,1); imagesc(image); colormap('gray'); title('image');
subplot(2,2,2); imagesc(template); colormap('gray');title('template');
for i=1:size(fit,2)
    %imtransform2 is specified in terms of right multiplication so need to
    %transpose transform matrix
   newImage = imtransform2(image,fit(i).warp_p');
   subplot(2,2,3);
   imagesc(newImage(1:50,1:50)); colormap('gray');
   drawnow;
   pause(.5); 
end